<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>AlexaClientSDK: /workplace/avs-device-sdk/MediaPlayer/AndroidSLESMediaPlayer/include/AndroidSLESMediaPlayer/AndroidSLESMediaQueue.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="avs-logo.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">AlexaClientSDK
   &#160;<span id="projectnumber">1.13.0</span>
   </div>
   <div id="projectbrief">A cross-platform, modular SDK for interacting with the Alexa Voice Service</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_9d34932954f3d83257e5e12e3f421a72.html">MediaPlayer</a></li><li class="navelem"><a class="el" href="dir_b97c8a12362aabf73b92afdea21f65db.html">AndroidSLESMediaPlayer</a></li><li class="navelem"><a class="el" href="dir_7b5c7f5aa6c9c2118e08133913118a4b.html">include</a></li><li class="navelem"><a class="el" href="dir_1c7bd630be78b850d01adb3bbc48faf9.html">AndroidSLESMediaPlayer</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">AndroidSLESMediaQueue.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_android_s_l_e_s_media_queue_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * Copyright 2018 Amazon.com, Inc. or its affiliates. All Rights Reserved.</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> * Licensed under the Apache License, Version 2.0 (the &quot;License&quot;).</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> * You may not use this file except in compliance with the License.</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> * A copy of the License is located at</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment"> *     http://aws.amazon.com/apache2.0/</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment"> * or in the &quot;license&quot; file accompanying this file. This file is distributed</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment"> * on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment"> * express or implied. See the License for the specific language governing</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment"> * permissions and limitations under the License.</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="preprocessor">#ifndef ALEXA_CLIENT_SDK_MEDIAPLAYER_ANDROIDSLESMEDIAPLAYER_INCLUDE_ANDROIDSLESMEDIAPLAYER_ANDROIDSLESMEDIAQUEUE_H_</span></div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="preprocessor">#define ALEXA_CLIENT_SDK_MEDIAPLAYER_ANDROIDSLESMEDIAPLAYER_INCLUDE_ANDROIDSLESMEDIAPLAYER_ANDROIDSLESMEDIAQUEUE_H_</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;</div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="preprocessor">#include &lt;array&gt;</span></div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="preprocessor">#include &lt;atomic&gt;</span></div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="preprocessor">#include &lt;chrono&gt;</span></div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="preprocessor">#include &lt;mutex&gt;</span></div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="preprocessor">#include &lt;vector&gt;</span></div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;</div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="preprocessor">#include &lt;SLES/OpenSLES_Android.h&gt;</span></div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;</div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_executor_8h.html">AVSCommon/Utils/Threading/Executor.h</a>&gt;</span></div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_android_s_l_e_s_object_8h.html">AndroidUtilities/AndroidSLESObject.h</a>&gt;</span></div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;</div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_decoder_interface_8h.html">AndroidSLESMediaPlayer/DecoderInterface.h</a>&quot;</span></div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_playback_configuration_8h.html">AndroidSLESMediaPlayer/PlaybackConfiguration.h</a>&quot;</span></div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;</div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespacealexa_client_s_d_k.html">alexaClientSDK</a> {</div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;<span class="keyword">namespace </span>mediaPlayer {</div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;<span class="keyword">namespace </span>android {</div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;</div><div class="line"><a name="l00047"></a><span class="lineno"><a class="line" href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_android_s_l_e_s_media_queue.html">   47</a></span>&#160;<span class="keyword">class </span><a class="code" href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_android_s_l_e_s_media_queue.html">AndroidSLESMediaQueue</a> {</div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00049"></a><span class="lineno"><a class="line" href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_android_s_l_e_s_media_queue.html#a7c3070e9a966b7e96caf25695b108ab5">   49</a></span>&#160;    <span class="keyword">using</span> <a class="code" href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_android_s_l_e_s_media_queue.html#a7c3070e9a966b7e96caf25695b108ab5">Byte</a> = <a class="code" href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_decoder_interface.html#a61064239f4eac92ed319f90ec93aa3df">DecoderInterface::Byte</a>;</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;</div><div class="line"><a name="l00052"></a><span class="lineno"><a class="line" href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_android_s_l_e_s_media_queue.html#afdfda08735cf877ed378547a19fadef7">   52</a></span>&#160;    <span class="keyword">enum class</span> <a class="code" href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_android_s_l_e_s_media_queue.html#afdfda08735cf877ed378547a19fadef7">QueueEvent</a> {</div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;        <a class="code" href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_android_s_l_e_s_media_queue.html#afdfda08735cf877ed378547a19fadef7abb1ca97ec761fc37101737ba0aa2e7c5">ERROR</a>,</div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;        <a class="code" href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_android_s_l_e_s_media_queue.html#afdfda08735cf877ed378547a19fadef7ad5ccba9de88aaed377f309401e79ca0d">FINISHED_READING</a>,</div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;        <a class="code" href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_android_s_l_e_s_media_queue.html#afdfda08735cf877ed378547a19fadef7aa29397782518e32fb22630b8d2ad5dc5">FINISHED_PLAYING</a></div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;    };</div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;</div><div class="line"><a name="l00068"></a><span class="lineno"><a class="line" href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_android_s_l_e_s_media_queue.html#aaf7e7bc636b84e92b72c25a50849ca0f">   68</a></span>&#160;    <span class="keyword">using</span> <a class="code" href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_android_s_l_e_s_media_queue.html#aaf7e7bc636b84e92b72c25a50849ca0f">EventCallback</a> = std::function&lt;void(QueueEvent event, const std::string&amp; reason)&gt;;</div><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;</div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;    <span class="keyword">static</span> std::unique_ptr&lt;AndroidSLESMediaQueue&gt; <a class="code" href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_android_s_l_e_s_media_queue.html#ae6ee5c6f3d2dfdca3f25ca879e05b0ae">create</a>(</div><div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;        std::shared_ptr&lt;applicationUtilities::androidUtilities::AndroidSLESObject&gt; queueObject,</div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;        std::unique_ptr&lt;DecoderInterface&gt; decoder,</div><div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;        <a class="code" href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_android_s_l_e_s_media_queue.html#aaf7e7bc636b84e92b72c25a50849ca0f">EventCallback</a> onStatusChanged,</div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;        <span class="keyword">const</span> <a class="code" href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_playback_configuration.html">PlaybackConfiguration</a>&amp; playbackConfiguration);</div><div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;</div><div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_android_s_l_e_s_media_queue.html#a12dfd7dff881e60a525ed0854f7ae39f">onBufferFree</a>();</div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;</div><div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;    <a class="code" href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_android_s_l_e_s_media_queue.html#a5ca5ad828939b3fe46cd73e241b5ad5a">~AndroidSLESMediaQueue</a>();</div><div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;</div><div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;    <span class="keywordtype">size_t</span> <a class="code" href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_android_s_l_e_s_media_queue.html#a3630e3478b4335d02393ea1de1c4f736">getNumBytesBuffered</a>() <span class="keyword">const</span>;</div><div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;</div><div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;    <span class="keywordtype">size_t</span> <a class="code" href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_android_s_l_e_s_media_queue.html#aef60ddab6a82c084f61e77e0a6ea7f5b">getNumBytesPlayed</a>() <span class="keyword">const</span>;</div><div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;</div><div class="line"><a name="l00114"></a><span class="lineno"><a class="line" href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_android_s_l_e_s_media_queue.html#a663c2c715b7a0d980c24db4d294e4fee">  114</a></span>&#160;    <span class="keyword">static</span> constexpr <span class="keywordtype">size_t</span> <a class="code" href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_android_s_l_e_s_media_queue.html#a663c2c715b7a0d980c24db4d294e4fee">NUMBER_OF_BUFFERS</a>{4u};</div><div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;</div><div class="line"><a name="l00117"></a><span class="lineno"><a class="line" href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_android_s_l_e_s_media_queue.html#a3cd17788f1d11c1130641b5efa2e852c">  117</a></span>&#160;    <span class="keyword">static</span> constexpr <span class="keywordtype">size_t</span> <a class="code" href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_android_s_l_e_s_media_queue.html#a3cd17788f1d11c1130641b5efa2e852c">BUFFER_SIZE</a>{131072u};</div><div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;</div><div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;<span class="keyword">private</span>:</div><div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;    <a class="code" href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_android_s_l_e_s_media_queue.html">AndroidSLESMediaQueue</a>(</div><div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;        std::shared_ptr&lt;applicationUtilities::androidUtilities::AndroidSLESObject&gt; queueObject,</div><div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;        SLAndroidSimpleBufferQueueItf bufferQueue,</div><div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;        std::unique_ptr&lt;DecoderInterface&gt; decoder,</div><div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;        <a class="code" href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_android_s_l_e_s_media_queue.html#aaf7e7bc636b84e92b72c25a50849ca0f">EventCallback</a> callbackFunction);</div><div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;</div><div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;    <span class="keywordtype">void</span> fillBuffer();</div><div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;</div><div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;    <span class="keywordtype">void</span> fillAllBuffers(<span class="keyword">const</span> <a class="code" href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_playback_configuration.html">PlaybackConfiguration</a>&amp; configuration);</div><div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;</div><div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;    <span class="keywordtype">void</span> enqueueSilence(<span class="keyword">const</span> <a class="code" href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_playback_configuration.html">PlaybackConfiguration</a>&amp; configuration);</div><div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;</div><div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;    <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1threading_1_1_executor.html">avsCommon::utils::threading::Executor</a> m_executor;</div><div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;</div><div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;    std::shared_ptr&lt;applicationUtilities::androidUtilities::AndroidSLESObject&gt; m_slObject;</div><div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;</div><div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;    SLAndroidSimpleBufferQueueItf m_queueInterface;</div><div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;</div><div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;    std::array&lt;std::array&lt;Byte, BUFFER_SIZE&gt;, <a class="code" href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_android_s_l_e_s_media_queue.html#a663c2c715b7a0d980c24db4d294e4fee">NUMBER_OF_BUFFERS</a>&gt; m_buffers;</div><div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;</div><div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;    std::vector&lt;size_t&gt; m_bufferSizes;</div><div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;</div><div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;    std::unique_ptr&lt;DecoderInterface&gt; m_decoder;</div><div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;</div><div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;    <span class="keywordtype">size_t</span> m_index;</div><div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;</div><div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;    <span class="keywordtype">bool</span> m_inputEof;</div><div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;</div><div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;    <span class="keywordtype">bool</span> m_failure;</div><div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;</div><div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;    <a class="code" href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_android_s_l_e_s_media_queue.html#aaf7e7bc636b84e92b72c25a50849ca0f">EventCallback</a> m_eventCallback;</div><div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;</div><div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160;    std::atomic&lt;size_t&gt; m_bufferedWords;</div><div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160;</div><div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;    std::atomic&lt;size_t&gt; m_playedWords;</div><div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;};</div><div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;</div><div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;}  <span class="comment">// namespace android</span></div><div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;}  <span class="comment">// namespace mediaPlayer</span></div><div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;}  <span class="comment">// namespace alexaClientSDK</span></div><div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;</div><div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;<span class="preprocessor">#endif  // ALEXA_CLIENT_SDK_MEDIAPLAYER_ANDROIDSLESMEDIAPLAYER_INCLUDE_ANDROIDSLESMEDIAPLAYER_ANDROIDSLESMEDIAQUEUE_H_</span></div><div class="ttc" id="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_android_s_l_e_s_media_queue_html_ae6ee5c6f3d2dfdca3f25ca879e05b0ae"><div class="ttname"><a href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_android_s_l_e_s_media_queue.html#ae6ee5c6f3d2dfdca3f25ca879e05b0ae">alexaClientSDK::mediaPlayer::android::AndroidSLESMediaQueue::create</a></div><div class="ttdeci">static std::unique_ptr&lt; AndroidSLESMediaQueue &gt; create(std::shared_ptr&lt; applicationUtilities::androidUtilities::AndroidSLESObject &gt; queueObject, std::unique_ptr&lt; DecoderInterface &gt; decoder, EventCallback onStatusChanged, const PlaybackConfiguration &amp;playbackConfiguration)</div><div class="ttdef"><b>Definition:</b> AndroidSLESMediaQueue.cpp:49</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_playback_configuration_html"><div class="ttname"><a href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_playback_configuration.html">alexaClientSDK::mediaPlayer::android::PlaybackConfiguration</a></div><div class="ttdef"><b>Definition:</b> PlaybackConfiguration.h:40</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_android_s_l_e_s_media_queue_html_afdfda08735cf877ed378547a19fadef7"><div class="ttname"><a href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_android_s_l_e_s_media_queue.html#afdfda08735cf877ed378547a19fadef7">alexaClientSDK::mediaPlayer::android::AndroidSLESMediaQueue::QueueEvent</a></div><div class="ttdeci">QueueEvent</div><div class="ttdoc">Represent the event types that will be sent to the StatusCallback when the queue change state...</div><div class="ttdef"><b>Definition:</b> AndroidSLESMediaQueue.h:52</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_decoder_interface_html_a61064239f4eac92ed319f90ec93aa3df"><div class="ttname"><a href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_decoder_interface.html#a61064239f4eac92ed319f90ec93aa3df">alexaClientSDK::mediaPlayer::android::DecoderInterface::Byte</a></div><div class="ttdeci">uint8_t Byte</div><div class="ttdoc">Represents one byte of data. </div><div class="ttdef"><b>Definition:</b> DecoderInterface.h:38</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_android_s_l_e_s_media_queue_html_afdfda08735cf877ed378547a19fadef7ad5ccba9de88aaed377f309401e79ca0d"><div class="ttname"><a href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_android_s_l_e_s_media_queue.html#afdfda08735cf877ed378547a19fadef7ad5ccba9de88aaed377f309401e79ca0d">alexaClientSDK::mediaPlayer::android::AndroidSLESMediaQueue::QueueEvent::FINISHED_READING</a></div><div class="ttdoc">Sent when there is no more input data to feed the player. </div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1threading_1_1_executor_html"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1threading_1_1_executor.html">alexaClientSDK::avsCommon::utils::threading::Executor</a></div><div class="ttdef"><b>Definition:</b> Executor.h:39</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_android_s_l_e_s_media_queue_html_a3630e3478b4335d02393ea1de1c4f736"><div class="ttname"><a href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_android_s_l_e_s_media_queue.html#a3630e3478b4335d02393ea1de1c4f736">alexaClientSDK::mediaPlayer::android::AndroidSLESMediaQueue::getNumBytesBuffered</a></div><div class="ttdeci">size_t getNumBytesBuffered() const</div><div class="ttdef"><b>Definition:</b> AndroidSLESMediaQueue.cpp:224</div></div>
<div class="ttc" id="_android_s_l_e_s_object_8h_html"><div class="ttname"><a href="_android_s_l_e_s_object_8h.html">AndroidSLESObject.h</a></div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_android_s_l_e_s_media_queue_html_afdfda08735cf877ed378547a19fadef7abb1ca97ec761fc37101737ba0aa2e7c5"><div class="ttname"><a href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_android_s_l_e_s_media_queue.html#afdfda08735cf877ed378547a19fadef7abb1ca97ec761fc37101737ba0aa2e7c5">alexaClientSDK::mediaPlayer::android::AndroidSLESMediaQueue::QueueEvent::ERROR</a></div><div class="ttdoc">Sent when the queue encountered an unrecoverable error. </div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_android_s_l_e_s_media_queue_html_aef60ddab6a82c084f61e77e0a6ea7f5b"><div class="ttname"><a href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_android_s_l_e_s_media_queue.html#aef60ddab6a82c084f61e77e0a6ea7f5b">alexaClientSDK::mediaPlayer::android::AndroidSLESMediaQueue::getNumBytesPlayed</a></div><div class="ttdeci">size_t getNumBytesPlayed() const</div><div class="ttdef"><b>Definition:</b> AndroidSLESMediaQueue.cpp:220</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_android_s_l_e_s_media_queue_html_aaf7e7bc636b84e92b72c25a50849ca0f"><div class="ttname"><a href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_android_s_l_e_s_media_queue.html#aaf7e7bc636b84e92b72c25a50849ca0f">alexaClientSDK::mediaPlayer::android::AndroidSLESMediaQueue::EventCallback</a></div><div class="ttdeci">std::function&lt; void(QueueEvent event, const std::string &amp;reason)&gt; EventCallback</div><div class="ttdef"><b>Definition:</b> AndroidSLESMediaQueue.h:68</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_android_s_l_e_s_media_queue_html_a663c2c715b7a0d980c24db4d294e4fee"><div class="ttname"><a href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_android_s_l_e_s_media_queue.html#a663c2c715b7a0d980c24db4d294e4fee">alexaClientSDK::mediaPlayer::android::AndroidSLESMediaQueue::NUMBER_OF_BUFFERS</a></div><div class="ttdeci">static constexpr size_t NUMBER_OF_BUFFERS</div><div class="ttdoc">The number of buffers to use. </div><div class="ttdef"><b>Definition:</b> AndroidSLESMediaQueue.h:114</div></div>
<div class="ttc" id="_playback_configuration_8h_html"><div class="ttname"><a href="_playback_configuration_8h.html">PlaybackConfiguration.h</a></div></div>
<div class="ttc" id="_executor_8h_html"><div class="ttname"><a href="_executor_8h.html">Executor.h</a></div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_android_s_l_e_s_media_queue_html_a5ca5ad828939b3fe46cd73e241b5ad5a"><div class="ttname"><a href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_android_s_l_e_s_media_queue.html#a5ca5ad828939b3fe46cd73e241b5ad5a">alexaClientSDK::mediaPlayer::android::AndroidSLESMediaQueue::~AndroidSLESMediaQueue</a></div><div class="ttdeci">~AndroidSLESMediaQueue()</div><div class="ttdef"><b>Definition:</b> AndroidSLESMediaQueue.cpp:95</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_android_s_l_e_s_media_queue_html_a7c3070e9a966b7e96caf25695b108ab5"><div class="ttname"><a href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_android_s_l_e_s_media_queue.html#a7c3070e9a966b7e96caf25695b108ab5">alexaClientSDK::mediaPlayer::android::AndroidSLESMediaQueue::Byte</a></div><div class="ttdeci">DecoderInterface::Byte Byte</div><div class="ttdef"><b>Definition:</b> AndroidSLESMediaQueue.h:49</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_android_s_l_e_s_media_queue_html"><div class="ttname"><a href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_android_s_l_e_s_media_queue.html">alexaClientSDK::mediaPlayer::android::AndroidSLESMediaQueue</a></div><div class="ttdef"><b>Definition:</b> AndroidSLESMediaQueue.h:47</div></div>
<div class="ttc" id="namespacealexa_client_s_d_k_html"><div class="ttname"><a href="namespacealexa_client_s_d_k.html">alexaClientSDK</a></div><div class="ttdoc">Whether or not curl logs should be emitted. </div><div class="ttdef"><b>Definition:</b> AVSConnectionManager.h:37</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_android_s_l_e_s_media_queue_html_a3cd17788f1d11c1130641b5efa2e852c"><div class="ttname"><a href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_android_s_l_e_s_media_queue.html#a3cd17788f1d11c1130641b5efa2e852c">alexaClientSDK::mediaPlayer::android::AndroidSLESMediaQueue::BUFFER_SIZE</a></div><div class="ttdeci">static constexpr size_t BUFFER_SIZE</div><div class="ttdoc">Buffer size for the decoded data. This has to be big enough to be used with the decoder. </div><div class="ttdef"><b>Definition:</b> AndroidSLESMediaQueue.h:117</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_android_s_l_e_s_media_queue_html_afdfda08735cf877ed378547a19fadef7aa29397782518e32fb22630b8d2ad5dc5"><div class="ttname"><a href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_android_s_l_e_s_media_queue.html#afdfda08735cf877ed378547a19fadef7aa29397782518e32fb22630b8d2ad5dc5">alexaClientSDK::mediaPlayer::android::AndroidSLESMediaQueue::QueueEvent::FINISHED_PLAYING</a></div><div class="ttdoc">Sent when all buffers are free and playing is over. </div></div>
<div class="ttc" id="_decoder_interface_8h_html"><div class="ttname"><a href="_decoder_interface_8h.html">DecoderInterface.h</a></div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_android_s_l_e_s_media_queue_html_a12dfd7dff881e60a525ed0854f7ae39f"><div class="ttname"><a href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_android_s_l_e_s_media_queue.html#a12dfd7dff881e60a525ed0854f7ae39f">alexaClientSDK::mediaPlayer::android::AndroidSLESMediaQueue::onBufferFree</a></div><div class="ttdeci">void onBufferFree()</div><div class="ttdef"><b>Definition:</b> AndroidSLESMediaQueue.cpp:91</div></div>
</div><!-- fragment --></div><!-- contents -->
<html>
  <body>
    <p style="text-align:left;">
      AlexaClientSDK 1.13.0 - Copyright 2016-2019 Amazon.com, Inc. or its affiliates. All Rights Reserved.
      <span style="float:right;">
	Licensed under the <a HREF=http://aws.amazon.com/apache2.0/>Apache License, Version 2.0</a>
      </span>
    </p>
  </body>
</html>
